function result = BI_solver_g(g,Y,V, r,c,Paras)
% Created on 08-06
%% Parameters
if isfield(Paras, "ite_max")
    ite_max = Paras.ite_max;
else
    ite_max = 100;
end

if isfield(Paras, "stop_cri")
    stop_cri = Paras.stop_cri;
else
    stop_cri = 1e-5;
end

if isfield(Paras, "rho_lambda")
    rho_lambda = Paras.rho_lambda;
else
    rho_lambda = 100;
end

if isfield(Paras, "rho_mu")
    rho_mu = Paras.rho_mu;
else
    rho_mu = 100;
end

if isfield(Paras, "N_step")
    N_step = Paras.N_step;
else
    N_step = 100;
end
%%
result = struct; [N,P] = size(Y);
Z = kr(Y'*V,V);
mu = 0;
lambda = zeros(N*P,1);
Gamma= rho_lambda*(Z'*Z)+rho_mu*(r*r');
g_old = g;
for n_step = 1:N_step
    x = Srho(Z*g + lambda/rho_lambda, 1/rho_lambda);
    g = Gamma\(Z'*(rho_lambda*x - lambda)+(rho_mu*c - mu)*r);
    lambda = lambda + rho_lambda*(Z*g - x);
    mu = mu + rho_mu*(r'*g - c);
    RE_v = norm(g - g_old)/(1e-10 + norm(g_old));
    if RE_v <= stop_cri
        break;
    else
        g_old = g;
    end
end
result.g = g;
result.x = x;
result.lambda = lambda;
result.mu = mu;
result.ite = n_step;
result.RE_v = RE_v;
end
