clear; close all; clc;
%% Default parameters
% Signal 
N = 20; T = 40; theta = 0.15; symmetry = 1; S = ceil(N*theta); eta = 0; L = N;
% Filter
alpha = 0.5;
% Graph
pEdge = 0.4;
% Experiment
rho_mu_batch = 100; rho_lambda_batch = 100;
N_step = 100; stop_cri = 1e-3;
ksi = 0;
rho_mu = 100; rho_lambda = 100; 

nRealiz = 50;

%%
% experiment_plan = 11;
experiment_plan = 9;
save_name = string(datetime("now",'Format','mm-DD-yyyy_HH-MM'))+'_exp_'+num2str(experiment_plan)+'.mat';
comment = 'Example for RBDoGS';
%% Control parameters

switch experiment_plan
    case 1
        para1_0 = 0.05*N; nPara1 = 10; dPara1 = 0.05*N; namePara1 = 'alpha';
        para2_0 = 2;  nPara2 = 10; dPara2 = 2; namePara2 = 'T';
        theta = 0.3; S = ceil(N*theta); 
        sgtitl = ['N = ', num2str(N), ', \theta = ', num2str(theta), ', nRealiz = ', num2str(nRealiz)];
    case 2
        alpha = 0.05*N;
        para1_0 = 0.1; nPara1 = 10; dPara1 = para1_0; namePara1 = 'theta';
        para2_0 = 4;  nPara2 = 10; dPara2 = 4; namePara2 = 'T';
        sgtitl = ['N = ', num2str(N), ', \alpha = ', num2str(alpha), ', nRealiz = ', num2str(nRealiz)];
    case 3
        alpha = 0.05*N;theta = 0.3; S = ceil(N*theta);  
        para1_0 = 0.05; nPara1 = 10; dPara1 = para1_0; namePara1 = 'eta';
        para2_0 = 4;  nPara2 = 10; dPara2 = 4; namePara2 = 'T';
        sgtitl = ['N = ', num2str(N), ', \theta = ', num2str(theta), ', \alpha = ', num2str(alpha), ', nRealiz = ', num2str(nRealiz)]; 
    case 4
        para1_0 = 0.05*N; nPara1 = 10; dPara1 = 0.05*N; namePara1 = 'alpha';
        para2_0 = 0.1; nPara2 = 10; dPara2 = para2_0; namePara2 = 'theta';
        T = N; 
        sgtitl = ['N = ', num2str(N), ', T = ', num2str(T), ', nRealiz = ', num2str(nRealiz)];    
    case 5
        T = N; theta = 0.1; S = ceil(N*theta);  
        para1_0 = 0.05; nPara1 = 10; dPara1 = para1_0; namePara1 = 'eta';
        para2_0 = 0.05*N; nPara2 = 10; dPara2 = 0.05*N; namePara2 = 'alpha';
        sgtitl = ['N = ', num2str(N), ', \theta = ', num2str(theta), ', T = ', num2str(T), ', nRealiz = ', num2str(nRealiz)]; 
    case 6
        alpha = 0.05*N;theta = 0.3; S = ceil(N*theta);  
        para1_0 = 1; nPara1 = 6; dPara1 = para1_0; namePara1 = 'L';
        para2_0 = 4;  nPara2 = 10; dPara2 = 4; namePara2 = 'T';
        sgtitl = ['N = ', num2str(N), ', \theta = ', num2str(theta), ', \alpha = ', num2str(alpha), ', nRealiz = ', num2str(nRealiz)]; 
    case 7
        alpha = 0.05*N;theta = 0.3; S = ceil(N*theta);  
        para1_0 = 10; nPara1 = 5; dPara1 = para1_0; namePara1 = 'N';
        para2_0 = 4;  nPara2 = 10; dPara2 = 4; namePara2 = 'T';
        sgtitl = ['N = ', num2str(N), ', \theta = ', num2str(theta), ', \alpha = ', num2str(alpha), ', nRealiz = ', num2str(nRealiz)]; 
    case 8
        alpha = 0.05*N;
        para1_0 = 0.1; nPara1 = 10; dPara1 = para1_0; namePara1 = 'theta';
        para2_0 = 10;  nPara2 = 5; dPara2 = 10; namePara2 = 'N';
        sgtitl = ['N = ', num2str(N), ', \alpha = ', num2str(alpha), ', nRealiz = ', num2str(nRealiz)];
    case 9
        T = 3*N; theta = 0.15; S = ceil(N*theta);  
        para1_0 = 0; nPara1 = 5; dPara1 = 1; namePara1 = 'xi'; labely = '\xi';
        para2_0 = 0.02*N; nPara2 = 5; dPara2 = 0.02*N; namePara2 = 'alpha'; labelx = '\alpha';
        sgtitl = ['N = ', num2str(N), ', \theta = ', num2str(theta), ', T = ', num2str(T), ', nRealiz = ', num2str(nRealiz)]; 
    case 10
        alpha = 0.5; theta = 0.15; S = ceil(N*theta);  
        para1_0 = 0.5; nPara1 = 5; dPara1 = 0.5; namePara1 = 'xi';
        para2_0 = 0.5*N; nPara2 = 5; dPara2 = 0.5*N; namePara2 = 'T';
        sgtitl = ['N = ', num2str(N), ', \theta = ', num2str(theta), ', alpha = ', num2str(alpha), ', nRealiz = ', num2str(nRealiz)]; 
    case 11
        alpha = 0.05*N;
        para1_0 = 0.1; nPara1 = 5; dPara1 = para1_0; namePara1 = 'beta'; labely = '\beta';
        para2_0 = 10*N;  nPara2 = 5; dPara2 = 5*N; namePara2 = 'T'; labelx = 'T';
        sgtitl = ['N = ', num2str(N), ', \alpha = ', num2str(alpha), ', nRealiz = ', num2str(nRealiz)];        
              
end

Ps1 = para1_0 + dPara1*(0:(nPara1-1));
Ps2 = para2_0 + dPara2*(0:(nPara2-1));
% Metrics
nMetrics = 4; metrics = {'1 - Re_g', '1 - Re_x', 'ACC', '1 - Re_V'}; supp_thres = 0.1;
models = {'True V', 'BDoG', 'RBDoGS'}; nModel = size(models,2); 
results = zeros(nPara1, nPara2, nRealiz, nMetrics, nModel);
objs = zeros(nPara1, nPara2, nRealiz, N_step, 2);


%% Experiments
N_non_solvable_break = 0;
for p1 = 1:nPara1
    for p2 = 1:nPara2
        switch experiment_plan
            case 1
                alpha = Ps1(p1); 
                T = Ps2(p2); 
            case 2
                theta = Ps1(p1);
                S = ceil(N*theta);
                T = Ps2(p2);
            case 3
                eta = Ps1(p1);
                T = Ps2(p2);
            case 4
                theta = Ps2(p2);
                S = ceil(N*theta);
                alpha = Ps1(p1);    
            case 5
                eta = Ps1(p1);
                alpha = Ps2(p2);       
            case 6
                L = Ps1(p1);
                T = Ps2(p2);            
            case 7  
                N = Ps1(p1);
                T = Ps2(p2);     
                alpha = 0.05*N; S = ceil(N*theta); L = N;
            case 8
                theta = Ps1(p1);
                N = Ps2(p2); 
                S = ceil(N*theta); alpha = 1; L = N;
            case 9
                ksi = Ps1(p1);
                alpha = Ps2(p2);         
            case 10
                ksi = Ps1(p1);
                T = Ps2(p2);    
            case 11
                beta = Ps1(p1);
                T = Ps2(p2);                  
        end
        nr = 1;
        while nr <= nRealiz
            paras_X = struct; paras_X.P = T; paras_X.N = N; paras_X.S = S; paras_X.mu = 0; paras_X.sigma = 1; paras_X.symmetry = symmetry;
            X0 = X_generate(paras_X);         
            noise = randn(N,T); noise =  noise/norm(noise)*norm(X0);

            % V from connected ER graph
            [An,lambda,V] = connected_nonpermu_ER_generate_v3(N,pEdge);
            Vinv = inv(V); Phi = fliplr(vander(lambda));  Psi = Phi(:,1:L); M = V*kr(Psi',Vinv')'; % Find the operator M

            % Graph filter
            if experiment_plan == 11
               h = 2*rand(L,1)-1; h = beta*h/norm(h); h(1) = 1; tbh = Psi*h; tbg = 1./tbh; tbg = tbg*N/sum(tbg); tbh = 1./tbg;
               H = V*diag(tbh)*V'; G = V*diag(tbg)*V'; g = G(:);
            else
                Porth1 = eye(N) - ones(N,N)/N; b = Porth1*rand(N,1); b = b/(norm(b)+1e-10); tbg = ones(N,1) + alpha*b; tbh = 1./tbg; %h = Phi\tbh;
                G = V*diag(tbg)*V'; g = G(:);
            end
            Y = V*diag(tbh)*V'*X0; Y = Y + eta*noise; Z = kr(Y'*V,inv(V)'); r = ones(N,1); c = N;
            x0 = X0(:);
            
            A = An; I = eye(N);  [Va,La] = eig(A); 
            Wp = 1 - 0.5*rand(N,N); Wp = Wp - Wp'; Wp = Wp/norm(Wp,'fro');
            Cxi = (eye(N) + ksi*Wp)\(eye(N) - ksi*Wp);
            Vper = Cxi*Va;

            % True Graph
            result = ADMM_BI_batch(Z,r,c,rho_lambda_batch,rho_mu_batch, N_step, stop_cri); v = result.g; x = result.x;
            if norm(tbg - v) > norm(tbg + v)
                v = -v;
            end     
            re_batch = norm(tbg - v)/norm(tbg); 
            re_batch_x = norm(x - X0(:))/norm(X0(:)); 

            % BDoG
            Zper = kr(Y'*Vper,inv(Vper)');
            result1 = ADMM_BI_batch(Zper,r,c,rho_lambda_batch,rho_mu_batch, N_step, stop_cri); 
            v1 = result1.g; xr1 = result1.x;
            Gr1 = Vper*diag(v1)*Vper'; gr1 = Gr1(:);
            if norm(gr1-g) > norm(g + gr1)
                gr1 = -gr1; xr1 = -xr1;
            end     
            re_g_new1 = norm(g - gr1)/norm(g);  re_x_new1 = norm(xr1 - X0(:))/norm(X0(:));

            % RBDoGS
            rho_s = 10; ite_max = 100; Vs = Vper; 
            Paras.rho_lambda = rho_lambda; Paras.rho_mu = rho_mu;
            Paras.g_init = ones(N,1); Paras.rho_s = rho_s;
            result3 = ADMM_BI_batch_V_correct_CayleySGD_huber(Y,Vs, r,c,Paras);
            g3 = result3.g; xr3 = result3.x; V3 = result3.V; Gr3 = V3*diag(g3)*V3'; gr3 = Gr3(:);
            if norm(g - gr3) > norm(g+gr3)
                gr3 = -gr3; xr3 = -xr3;
            end            
            re_g_new3 = norm(g - gr3)/norm(g); 
            re_x_new3 = norm(xr3 - x0)/norm(x0);
            
            acc_new3 = mean(abs(xr3 - X0(:)) < supp_thres);
            objs(p1,p2,nr,:,2) = result3.obj_g;
            

            supp_0 = abs(X0(:)) > supp_thres;
            supp_batch = abs(x) > supp_thres; 
            acc_batch = sum(supp_batch.*supp_0 + (1-supp_batch).*(1-supp_0))/(sum(supp_batch) + sum(1-supp_batch));
            supp_1 = abs(xr1) > supp_thres; 
            acc_1 = sum(supp_1.*supp_0 + (1-supp_1).*(1-supp_0))/(sum(supp_1) + sum(1-supp_1));            
            supp_3 = abs(xr3) > supp_thres; 
            acc_3 = sum(supp_3.*supp_0 + (1-supp_3).*(1-supp_0))/(sum(supp_3) + sum(1-supp_3));
                        
            
            re_V_3 = norm(V3 - V,'fro')/norm(V,'fro')/2;
            re_V_1 = norm(Vper - V,'fro')/norm(V,'fro')/2;
            results(p1,p2,nr,:,1) = [re_batch,re_batch_x,1 - acc_batch, 0]; 
            results(p1,p2,nr,:,2) = [re_x_new1,re_g_new1,1 - acc_1, 1-re_V_1]; 
            results(p1,p2,nr,:,3) = [re_x_new3,re_g_new3,1 - acc_3, 1-re_V_3];  

            fprintf([namePara1, ' = ',num2str(Ps1(p1)),', ', namePara2,' = ', num2str(Ps2(p2)), ', n realiz = ', num2str(nr), '. Err: batch = ', num2str(re_batch),', ReX(methods) = [',num2str(re_x_new1), ...
                ', ', num2str(re_x_new3),'], acc = [', num2str(acc_1), ', ', num2str(acc_3),']\n']);
                        
            if (re_g_new3 >= 0.99)
                continue
            else
                nr = nr + 1;
            end
        end
    end
end
%%
save(save_name,'results','objs','Ps1','Ps2','metrics','models','N','T','theta','nRealiz','comment','namePara1','namePara2');

%% Plot

close all;n_fig = 1; 
Nx = nPara1; Ny = nPara2;
metrics= ["1-Reg","1-Rex", "ACC", "1-ReV"]; models = {'True_V', 'BDoG', 'RBDoGS'};
for n_model = [2,3]
    for nPlot = 1:nMetrics - 1
        n_fig = n_fig + 1; 
        figure(n_fig);
        fig = gcf; fig.PaperPositionMode = 'auto'; fig_pos = fig.PaperPosition; 
        fig.PaperSize = [fig_pos(3) fig_pos(4)];
        imagesc(Ps2,Ps1,1 -mean(results(1:Nx,1:Ny,:,nPlot,n_model),3),[0,1]); colormap('gray'); colorbar; 
        xlabel(labelx,'Fontsize',30); ylabel(labely,'Fontsize',30);
        pos = [340 300 300 250];
        pos_in = get(fig,'InnerPosition'); pos_out = get(fig,'OuterPosition');
        pos_paper = [0 0 4.2 3.5];
        set(fig,'Position',pos);
        set(fig,'PaperPosition',pos_paper);
        set(fig,'PaperSize',[pos_paper(3) pos_paper(4)]);
        file_name = [char(namePara1),'_',char(namePara2),'_',char(metrics(nPlot)),'_',char(models(n_model)),'-huber'];
        print(fig,file_name,'-dpdf')
    end
end

